# Class InputSelectOptionsDirective

#### Hierarchy (view full)

- OnDestroy
- AfterViewInit
- ExtractOptionsDataSourceMixin
  - InputSelectOptionsDirective

#### Implements

- OnDestroy
- AfterViewInit

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:85
- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:94

#####
Index

### Constructors

constructor

### Properties

cdr
control
dataSource
dataSourceLoader
injector
isAutocompleteToDisplayTriggered
matAutocomplete?
matFormField
metadata?
ngControl
options
settings?
subscription
template
useDataSourceValue?
viewContainerRef
viewer

### Methods

extractControl
extractDataSources
extractFormDefinition
extractOptionsDatasource
loadOptions
ngAfterViewInit
ngOnDestroy
renderTemplate
toDisplay

## Constructors

### constructor

- new InputSelectOptionsDirective(template, dataSourceLoader, viewContainerRef, injector, cdr, ngControl?, matFormField?): InputSelectOptionsDirective

- #### Parameters

  - template: TemplateRef<InputSelectOptionsTemplateContext>
  - dataSourceLoader: DataSourceLoader
  - viewContainerRef: ViewContainerRef
  - injector: Injector
  - cdr: ChangeDetectorRef
  - ngControl: null | NgControl = null
  - matFormField: null | MatFormField = null

  #### Returns InputSelectOptionsDirective

  Inherited from ExtractOptionsDataSourceMixin.constructor

  - Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:124

## Properties

### `Protected` `Readonly` cdr

cdr: ChangeDetectorRef

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:134

### `Protected` control

control: RxapFormControl<any, any, any>

Inherited from ExtractOptionsDataSourceMixin.control

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:107

### `Protected` dataSource

dataSource: BaseDataSource<ControlOptions | Record<string, any>, BaseDataSourceMetadata, BaseDataSourceViewer<any>>

Inherited from ExtractOptionsDataSourceMixin.dataSource

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:109

### `Protected` `Readonly` dataSourceLoader

dataSourceLoader: DataSourceLoader

Inherited from ExtractOptionsDataSourceMixin.dataSourceLoader

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:128

### `Protected` `Readonly` injector

injector: Injector

Inherited from ExtractOptionsDataSourceMixin.injector

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:132

### `Private` isAutocompleteToDisplayTriggered

isAutocompleteToDisplayTriggered: boolean = false

This flag is used to prevent the setValue is called for each refresh of the options list. This is needed because the setValue method will trigger a new refresh of the options list. This results in an endless call stack. This flag is set to true if the setValue method is called once.

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:122

### `Optional` matAutocomplete

matAutocomplete?: MatAutocomplete

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:103

### `Protected` matFormField

matFormField: null | MatFormField = null

Inherited from ExtractOptionsDataSourceMixin.matFormField

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:142

### `Optional` metadata

metadata?: BaseDataSourceMetadata

Inherited from ExtractOptionsDataSourceMixin.metadata

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:100

### `Protected` ngControl

ngControl: null | NgControl = null

Inherited from ExtractOptionsDataSourceMixin.ngControl

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:139

### `Protected` options

options: null | ControlOptions | Record<string, any> = null

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:111

### `Protected` `Optional` settings

settings?: InputSelectOptionsSettings<any>

Inherited from ExtractOptionsDataSourceMixin.settings

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:113

### `Protected` `Readonly` subscription

subscription: Subscription = ...

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:105

### `Protected` `Readonly` template

template: TemplateRef<InputSelectOptionsTemplateContext>

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:126

### `Protected` `Optional` useDataSourceValue

useDataSourceValue?: UseDataSourceValue<ControlOptions | Record<string, any>, ControlOptions | Record<string, any>>

Inherited from ExtractOptionsDataSourceMixin.useDataSourceValue

- Defined in packages/angular/form-system/src/lib/mixins/extract-options-data-source.mixin.ts:74

### `Protected` `Readonly` viewContainerRef

viewContainerRef: ViewContainerRef

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:130

### viewer

viewer: BaseDataSourceViewer<any> = ...

Inherited from ExtractOptionsDataSourceMixin.viewer

- Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:97

## Methods

### `Protected` extractControl

- extractControl(ngControl?): RxapFormControl<any, any, any>

- #### Parameters

  - ngControl: null | NgControl | AbstractControlDirective = ...

  #### Returns RxapFormControl<any, any, any>

  Inherited from ExtractOptionsDataSourceMixin.extractControl

  - Defined in packages/angular/form-system/src/lib/mixins/extract-control.mixin.ts:16

### `Protected` extractDataSources

- extractDataSources(formDefinition, controlId): Map<string, UseDataSourceValue<any, any>>

- #### Parameters

  - formDefinition: FormDefinition<any, any, any>
  - controlId: string

  #### Returns Map<string, UseDataSourceValue<any, any>>

  Inherited from ExtractOptionsDataSourceMixin.extractDataSources

  - Defined in packages/angular/form-system/src/lib/mixins/extract-data-sources.mixin.ts:9

### `Protected` extractFormDefinition

- extractFormDefinition(control): FormDefinition<any, any, any>

- #### Parameters

  - control: AbstractControl<any>

  #### Returns FormDefinition<any, any, any>

  Inherited from ExtractOptionsDataSourceMixin.extractFormDefinition

  - Defined in packages/angular/form-system/src/lib/mixins/extract-form-definition.mixin.ts:10

### `Protected` extractOptionsDatasource

- extractOptionsDatasource(control?): BaseDataSource<ControlOptions | Record<string, any>, BaseDataSourceMetadata, BaseDataSourceViewer<any>>

- #### Parameters

  - `Optional` control: AbstractControl<any, any>

  #### Returns BaseDataSource<ControlOptions | Record<string, any>, BaseDataSourceMetadata, BaseDataSourceViewer<any>>

  Inherited from ExtractOptionsDataSourceMixin.extractOptionsDatasource

  - Defined in packages/angular/form-system/src/lib/mixins/extract-options-data-source.mixin.ts:76

### `Private` loadOptions

- loadOptions(dataSource?): void

- #### Parameters

  - dataSource: BaseDataSource<ControlOptions | Record<string, any>, BaseDataSourceMetadata, BaseDataSourceViewer<any>> = ...

  #### Returns void

  - Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:182

### ngAfterViewInit

- ngAfterViewInit(): void

- #### Returns void

  Inherited from AfterViewInit.ngAfterViewInit

  - Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:146

### ngOnDestroy

- ngOnDestroy(): void

- #### Returns void

  Inherited from OnDestroy.ngOnDestroy

  - Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:178

### `Protected` renderTemplate

- renderTemplate(options?): void

- #### Parameters

  - options: null | ControlOptions | Record<string, any> = ...

  #### Returns void

  - Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:221

### toDisplay

- toDisplay(value): string

- #### Parameters

  - value: any

  #### Returns string

  - Defined in packages/angular/form-system/src/lib/directives/input-select-options.directive.ts:170